/*                      LEKCJA12.C
//---------------------------------------------------------------------------
Temat:
        Wybr wielu elementw 
//---------------------------------------------------------------------------
Funkcje:
        EXT(222) void EntityLoop(      
        EXT(223) void DrawEntities(    
//---------------------------------------------------------------------------

EXT(222) void EntityLoop(      // 
             ulong     filter, // filtr wybierajcy zaznaczone elementy
             tCallBack func,   // funkcja Callback 
             void      *para,  // wskanik dla funkcji Callback 
             void      *edta,  // bufor dla danych tymczasowych
             ushort    esiz);  // wielko bufora

Opis:
    Funkcja przeszukuje ca list elementw rysunku.
    Dla kadego elementu, ktrego bit rozpoznawczy ustawiony jest w filtrze
    jest wywoywana funkcja 'CallBack' z parametrami 'para'.
    W buforze 'edta' (moe on mie warto NULL) znajduje si miejsce na 
    dodatkowe dane elementw o zmiennej dugoci.
    Na pierwszym miejscu definicji struktury danych (na ktre wskazuje 'para') 
    musi zawiera 't_entity' !

Przykad definicji:
        struct _data
        {
            t_entity ent;
            .              //
            .              // inne definicje
            .              //
        } data;

Return:
    0  = kontynuacja funkcji
    1  = przerwanie funkcji

Przykady wywoania:

    EntityLoop(filter,SelPid,&ent,edta,sizeof(edta));
    EntityLoop(1<<E_LINE,MojaFunkcja,&data,NULL,0);
//---------------------------------------------------------------------------

EXT(223) void DrawEntities(    // 
             ulong  *pid,      // lista z numerami 'ID'
             ushort num);      // liczba elementw

Opis:
    Funkcja rysuje elementy ktrych numer identyfikacyjny 'ID' znajduje si
    na licie.
    Przy uyciu funkcji 'Blink' mona uaktywni optycznie wiele elementw.

Przykad wywoania:
    DrawEntities(pids,pidnum);

//---------------------------------------------------------------------------
*/

//---------------------------------------------------------------------------
#include "std.h"
#include "megatyp.h"
#include "megacad.h"
#define MAXPIDS 500
//---------------------------------------------------------------------------
char edta[32000];               // bufor dla zmiennych danych
ulong pids[MAXPIDS];            // miejsce dla 500 numerw 'ID
ushort pidnum;                  // ilo numerw 'ID'
//---------------------------------------------------------------------------
short SelPid(void *argptr )
{
    t_entity  *ent;

    ent = argptr;
    if(ent->attr.col == GREEN)          // wybr elementw w kolorze zielonym
    {
        pids[pidnum] = ent->id;
        pidnum++;
    }
    if(pidnum == MAXPIDS)               // czy bufor jest peny ?
        return(BREAK_LOOP);
    else
        return(CONTINUE_LOOP);
}
//---------------------------------------------------------------------------
short DoDraw(void *ptr)
{
    DrawEntities(pids,pidnum);
}
//---------------------------------------------------------------------------
short main(char *filename, char *args)
{
    t_entity ent;
    ulong filter;
    char text1[50];
    char text2[50];

    pidnum = 0;                         // ustawienie licznika na '0'
    SetFuncText("migotanie zielonych");
    MouseHelp("przerwanie","przerwanie",HLP_INV(0,0,0));
    filter = 0xffffffff;                // wybr wszystkich elementw
    EntityLoop(filter,SelPid,&ent,edta,sizeof(edta));
    Blink(DoDraw,NULL);

    sprintf(text1,"znaleziono  %d  elementw rysunkowych", pidnum);
    sprintf(text2,"w kolorze zielonym  (FILTR=  %X)", filter);
    Message(text1,text2,NULL,NULL,"ok",3);

    return(0);
}
//---------------------------------------------------------------------------
